

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <math.h>



  int      BUSY (int address, int axis);
  int      GET_INPUT (int address, int input_number);
  int      GET_LO_MID_HI (int address, int axis, long int setting);
  int      GO_CW (int address, int axis);
  int      GO_CCW (int address, int axis);
  int      HARD_INPUT_CCW (int address, int axis);
  int      HARD_INPUT_CW (int address, int axis);
  int      HOME_CCW (int address, int axis);
  int      HOME_CW (int address, int axis);
  int      HOME_INPUT (int address, int axis);
  int      INDEX (int address, int axis, long int setting);
  int      INITIALIZE (int address, int axis);
  int      LIMIT_CONTROL (int address, int axis, int soft, int marker, int home);
  int      MOTION (int address, int axis, float Base_Speed, float Max_Speed, float Ramp_Value);
  int      ONE_AT_MAX_CCW (int address, int axis);
  int      ONE_AT_MAX_CW (int address, int axis);
  int      ORIGIN_INDEX_CCW (int address, int axis);
  int      ORIGIN_INDEX_CW (int address, int axis);
  int      POSITION (int address, int axis, long int Setting);
  int      RAMP_TO_BASE_CCW (int address, int axis);
  int      RAMP_TO_BASE_CW (int address, int axis);
  int      RAMP_TO_STOP_CW (int address, int axis);
  int      RAMP_TO_STOP_CCW (int address, int axis);
  long int READ_ENCODER (int address, int axis);
  long int READ_POSITION (int address, int axis);
  int      SET_ENCODER (int address, int axis, long int setting);
  int      SET_OUTPUT_1 (int address, int out5, int out4, int out3, int out2, int out1, int a_home_dir, int b_home_dir);
  int      SET_OUTPUT_2 (int address, int out10, int out9, int out8, int out7, int out6, int c_home_dir, int d_home_dir);
  int      SET_POSITION (int address, int axis, long int setting);
  int      SLEW_AT_BASE_CCW (int address, int axis);
  int      SLEW_AT_BASE_CW (int address, int axis);
  int      SOFT_INPUT_CCW (int address, int axis);
  int      SOFT_INPUT_CW (int address, int axis);
  int      STOP (int address, int axis);
  int      WAIT_FOR_STOP (int address, int axis);

void  IndexOnTheFlyCW (int  address, int  axis, long int  StopPosition);

void main()
{
   int address = 0x300;
   int axis = 1;

   INITIALIZE (address, axis);
   MOTION (address, axis, 100, 10000, 100000);
   do
   {
      SET_POSITION (address, axis, 0);
      HOME_CW (address, axis);
      IndexOnTheFlyCW (address, axis, 29501);
      printf ("%li\n", READ_POSITION (address, axis));
   }
   while (1);
}

void  IndexOnTheFlyCW (int  address, int  axis, long int  StopPosition)
{
   do
   {
   }
   while (READ_POSITION (address, axis) < StopPosition);
   RAMP_TO_STOP_CW (address, axis);
   do
   {
   }
   while (BUSY (address, axis));
}

int BUSY (int address, int axis)
{
   int a;
   int correct_add = address + 12 + axis * 4;

   outportb(correct_add,128+10);
   a = inportb(correct_add);

   if ((a&64)==64)
      {
      return 1;
      }
     else
      {
      return 0;
      }

}



int GET_INPUT (int address, int input_number)
{
   int value, correct_add;

   if (input_number > 5)
   {
      correct_add = address + 8;
      input_number -= 5;
   }
   else
   {
      correct_add = address;
   }

   outportb(correct_add, 8);
   value = inportb(correct_add);

   value = value - 128 - 64 - 32;


   switch (input_number)
   {

     case (5):
          if ((value&16)==16)
          {
              return(0);
          }
          else
          {
              return(1);
          }
          break;

     case (4):
          if ((value&8)==8)
          {
              return(0);
          }
          else
          {
              return(1);
          }
          break;

     case (3):
          if ((value&4)==4)
          {
              return(0);
          }
          else
          {
              return(1);
          }
          break;

     case (2):
          if ((value&2)==2)
          {
              return(0);
          }
          else
          {
              return(1);
          }
          break;

     case (1):
          if ((value&1)==1)
          {
              return(0);
          }
          else
          {
              return(1);
          }
          break;

   }
}


int GET_LO_MID_HI (int address, int axis, long int setting)
{
     switch (axis)
     {
     case (1):
          outportb(address + 17, (setting)&0xff);
          outportb(address + 18, (setting>>8)&0xff);
          outportb(address + 19, (setting>>16)&0xff);
          break;

     case (2):
          outportb(address + 21, (setting)&0xff);
          outportb(address + 22, (setting>>8)&0xff);
          outportb(address + 23, (setting>>16)&0xff);
          break;

     case (3):
          outportb(address + 25, (setting)&0xff);
          outportb(address + 26, (setting>>8)&0xff);
          outportb(address + 27, (setting>>16)&0xff);
          break;

     case (4):
          outportb(address + 29, (setting)&0xff);
          outportb(address + 30, (setting>>8)&0xff);
          outportb(address + 31, (setting>>16)&0xff);
          break;
     }
   return (0);
}


int GO_CCW (int address, int axis)

  {
     switch (axis)
     {
     case (1):
          outportb(address + 16, 65);
          outportb(address + 16, 23);
          break;

     case (2):
          outportb(address + 20, 65);
          outportb(address + 20, 23);
          break;

     case (3):
          outportb(address + 24, 65);
          outportb(address + 24, 23);
          break;

     case (4):
          outportb(address + 28, 65);
          outportb(address + 28, 23);
          break;
     }
  return (0);
  }


int GO_CW (int address, int axis)
  {
     switch (axis)
     {
     case (1):
          outportb(address + 16, 65);
          outportb(address + 16, 19);
          break;

     case (2):
          outportb(address + 20, 65);
          outportb(address + 20, 19);
          break;

     case (3):
          outportb(address + 24, 65);
          outportb(address + 24, 19);
          break;

     case (4):
          outportb(address + 28, 65);
          outportb(address + 28, 19);
          break;
     }
  return (0);
  }


int HARD_INPUT_CCW (int address, int axis)
{
   int a;
   int correct_add = address + 12 + axis * 4;

   outportb(correct_add, 128 + 3);
   a = inportb(correct_add + 1);

   if ((a&2)==2)
   {
      return 1;
   }
   else
   {
      return 0;
   }
}


int HARD_INPUT_CW (int address, int axis)
{
   int a;
   int correct_add = address + 12 + axis * 4;

   outportb(correct_add, 128 + 3);
   a = inportb(correct_add + 1);

   if ((a&1)==1)
   {
      return 1;
   }
   else
   {
      return 0;
   }
}


int HOME_CCW (int address, int axis)
{
   int correct_add = address + 12 + axis * 4;

   outportb(correct_add,64);
   outportb(correct_add,23);
   return (0);
}


int HOME_CW (int address, int axis)
{
   int correct_add = address + 12 + axis * 4;

   outportb(correct_add,64);
   outportb(correct_add,19);
   return (0);
}


int HOME_INPUT (int address, int axis)
{
   int a;
   int correct_add = address + 12 + axis * 4;

   outportb(correct_add,128+3);
   a = inportb(correct_add + 1);

   if ((a&32)==32)
   {
      return 1;
   }
   else
   {
      return 0;
   }
}


int INDEX (int address, int axis, long int setting)
{
      int correct_add = address + 12 + axis * 4;

      outportb(correct_add, 128+0);
      GET_LO_MID_HI (address, axis, setting);
      return (0);
}


int INITIALIZE (int address, int axis)
{

   INDEX (address, axis, 1000);
   MOTION (address, axis, 200, 10000, 200000);
   SET_ENCODER (address, axis, 0);
   SET_POSITION (address, axis, 0);
   LIMIT_CONTROL (address, axis, 1, 1, 1);
   SET_OUTPUT_1 (address, 0,0,0,0,0,1,1);
   SET_OUTPUT_2 (address, 0,0,0,0,0,1,1);
   return 0;
}


int LIMIT_CONTROL (int address, int axis, int soft, int marker, int home)
{
      int correct_add = address + 12 + axis * 4;

      int value = 128 + 64 + 1;

      if (home==1)
      {
      value += 8;
      }

      if (marker==1)
      {
      value += 4;
      }

      if (soft==1)
      {
      value += 2;
      }

      outportb(correct_add,value);

      return (0);
}


int MOTION (int address, int axis, float Base_Speed, float Max_Speed, float Ramp_Value)
{
     int Max_Setting;
     long int Optimum_Factor;
     int Ramp_Setting;
     int Base_Setting;
     int correct_add = address + 12 + axis * 4;


     Optimum_Factor = 300.0 * 16383.0 / Max_Speed;

     if (Optimum_Factor <= 2)
        {
        Optimum_Factor = 2;
        }

     if (Optimum_Factor >= 16383)
        {
        Optimum_Factor = 16383;
        }

     outportb(correct_add, 128 + 4);
     GET_LO_MID_HI (address, axis, Optimum_Factor);


     Max_Setting = Max_Speed * Optimum_Factor / 300.0;

     if (Max_Setting > 16383)
        {
        Max_Setting = 16383;
        }

     outportb(correct_add,128 + 2);
     GET_LO_MID_HI (address, axis, Max_Setting);


     Ramp_Setting = 150.0 * 9830400.0 / (Ramp_Value * Optimum_Factor);
     if (Ramp_Setting < 1)
        {
        Ramp_Setting = 1;
        }

     if (Ramp_Setting > 32767)
        {
        Ramp_Setting = 32767;
        }

     outportb(correct_add, 128 + 3);
     GET_LO_MID_HI (address, axis, Ramp_Setting);


     Base_Setting = Base_Speed * Optimum_Factor / 300.0;

     if (Base_Setting > 16383)
        {
        Base_Setting = 16383;
        }

     if (Base_Setting < 1)
        {
        Base_Setting = 1;
        }

     outportb(correct_add, 128 + 1);
     GET_LO_MID_HI (address, axis, Base_Setting);

     return (0);
}


int ONE_AT_MAX_CCW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 29);
      return (0);
}


int ONE_AT_MAX_CW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 25);
      return (0);
}


int ORIGIN_INDEX_CCW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 114);
      outportb(correct_add, 23);
      return (0);
}


int ORIGIN_INDEX_CW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 114);
      outportb(correct_add, 18);
      return (0);
}


int POSITION (int address, int axis, long int Setting)
{
      long int Num_to_Index;

      Num_to_Index = Setting - READ_POSITION(address, axis);

      if (Num_to_Index > 0)
      {
         INDEX(address, axis, Num_to_Index);
         GO_CW(address, axis);
      }
      else
      {
         INDEX(address, axis, -Num_to_Index);
         GO_CCW(address, axis);
      }

      return (0);
}


int RAMP_TO_BASE_CCW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 6);
      return (0);
}


int RAMP_TO_BASE_CW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 2);
      return (0);
}


int RAMP_TO_STOP_CW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 10);
      return (0);
}

int RAMP_TO_STOP_CCW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 14);
      return (0);
}


long int  READ_ENCODER (int address, int axis)
{
      long int a, b, c;
      long int Enc_Value;
      int correct_add = address + 12 + axis * 4;

      outportb(correct_add, 128+8);
      outportb(correct_add + 1, 1);
      outportb(correct_add + 2, 44);
      outportb(correct_add, 128+13);

      a = inportb(correct_add + 1);
      b = inportb(correct_add + 2);
      c = inportb(correct_add + 3);

      Enc_Value = a+b*256+c*256*256;

      if (Enc_Value > 8388608)
         {
         Enc_Value = Enc_Value - 16777216;
         }

      return (Enc_Value);
}


long int READ_POSITION (int address, int axis)
{
      long int a, b, c;
      long int Pos_Value;
      int correct_add = address + 12 + axis * 4;

      outportb(correct_add, 128+8);
      outportb(correct_add + 1, 1);
      outportb(correct_add + 2, 44);
      outportb(correct_add, 128+12);

      a = inportb(correct_add + 1);
      b = inportb(correct_add + 2);
      c = inportb(correct_add + 3);

      Pos_Value = a+b*256+c*256*256;

      return (Pos_Value);
}


int SET_ENCODER (int address, int axis, long int setting)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 128+7);
      GET_LO_MID_HI (address, axis, setting);
      return (0);
}


int SET_OUTPUT_1 (int address, int out5, int out4, int out3, int out2, int out1, int a_home_dir, int b_home_dir)
{

      int correct_add = address + 4;
      int value = out5 * 16 + out4 * 8 + out3 * 4 + out2 * 2 + out1;

      if (a_home_dir == 0)
      {
         value += 64;
      }

      if (b_home_dir == 0)
      {
         value += 128;
      }

      outportb(correct_add, value);
      return (0);
}

int SET_OUTPUT_2 (int address, int out10, int out9, int out8, int out7, int out6, int c_home_dir, int d_home_dir)
{

      int correct_add = address + 12;
      int value = out10 * 16 + out9 * 8 + out8 * 4 + out7 * 2 + out6;

      if (c_home_dir == 0)
      {
         value += 64;
      }

      if (d_home_dir == 0)
      {
         value += 128;
      }

      outportb(correct_add, value);
      return (0);
}



int SET_POSITION (int address, int axis, long int setting)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 128+6);
      GET_LO_MID_HI (address, axis, setting);
      return (0);
}


int SLEW_AT_BASE_CCW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 64);
      outportb(correct_add, 20);
      return (0);
}


int SLEW_AT_BASE_CW (int address, int axis)
{
      int correct_add = address + 12 + axis * 4;
      outportb(correct_add, 64);
      outportb(correct_add, 16);
      return (0);
}


int SOFT_INPUT_CCW (int address, int axis)
{
   int a;
   int correct_add = address + 12 + axis * 4;

   outportb(correct_add,128+3);
   a = inportb(correct_add + 1);
   if ((a&8)==8)
   {
      return 1;
   }
   else
   {
      return 0;
   }
}

int SOFT_INPUT_CW (int address, int axis)
{
   int a;
   int correct_add = address + 12 + axis * 4;

   outportb(correct_add,128+3);
   a = inportb(correct_add + 1);
   if ((a&4)==4)
   {
      return 1;
   }
   else
   {
      return 0;
   }
}


int STOP (int address, int axis)
{
   int correct_add = address + 12 + axis * 4;
   if (BUSY(address, axis))
   {
      outportb(correct_add,8);
   }
   return (0);
}


int WAIT_FOR_STOP (int address, int axis)
{
   while (BUSY(address, axis))
    {
    }
   return (0);
}


